--[[------------------------------------------------------------------------------------------------

Precision Hands Mod for Farming Simulator 2022
Author: Rusty Tractor Modding

--]]-----------------------------------------------------------------------------------------------


GUI = {}

GUI.MENU_SHOWINHELP = {
	"Off", "On",
}
GUI.MENU_SUPERSTRENGTH= {
	"Off", "On",
}
GUI.MENU_MAXDISTANCE_METRES = {
	"3m", "5m","10m","15m","20m","Unlimited",
}
GUI.MENU_MAXDISTANCE_FEET = {
	"10ft", "16ft","32ft","49ft","65ft","Unlimited",
}

GUI.VALUE_MAXDISTANCE = {
	3, 5,10,15,20,9999,
}
GUI.MENU_GRIPSTRENGTH = {
	"100%","200%","500%","1000%","1500%","Unlimited",
}
GUI.VALUE_GRIPSTRENGTH = {
	1, 2,5,10,15,9999,
}
GUI.MENU_PUSHPULLSPEED = {
	"10%","20%","30%","40%","50%","60%","70%","80%","90%","100%","110%","120%","130%","140%","150%","160%","170%","180%","190%","200%","210%","220%","230%","240%","250%","260%","270%","280%","290%","300%","400%","500%",
}
GUI.VALUE_PUSHPULLSPEED = {
	0.1,0.2,0.3,0.4,0.5,0.6,0.7,0.8,0.9,1.0,1.1,1.2,1.3,1.4,1.5,1.6,1.7,1.8,1.9,2.0,2.1,2.2,2.3,2.4,2.5,2.6,2.7,2.8,2.9,3.0,4.0,5.0
}
GUI.MENU_NUDGESPEED = {
	"10%","20%","30%","40%","50%","60%","70%","80%","90%","100%","110%","120%","130%","140%","150%","160%","170%","180%","190%","200%","210%","220%","230%","240%","250%","260%","270%","280%","290%","300%","400%","500%",
}
GUI.VALUE_NUDGESPEED = {
	0.1,0.2,0.3,0.4,0.5,0.6,0.7,0.8,0.9,1.0,1.1,1.2,1.3,1.4,1.5,1.6,1.7,1.8,1.9,2.0,2.1,2.2,2.3,2.4,2.5,2.6,2.7,2.8,2.9,3.0,4.0,5.0
}
GUI.MENU_VERTICALSPEED = {
	"10%","20%","30%","40%","50%","60%","70%","80%","90%","100%","110%","120%","130%","140%","150%","160%","170%","180%","190%","200%","210%","220%","230%","240%","250%","260%","270%","280%","290%","300%","400%","500%",
}
GUI.VALUE_VERTICALSPEED = {
	0.1,0.2,0.3,0.4,0.5,0.6,0.7,0.8,0.9,1.0,1.1,1.2,1.3,1.4,1.5,1.6,1.7,1.8,1.9,2.0,2.1,2.2,2.3,2.4,2.5,2.6,2.7,2.8,2.9,3.0,4.0,5.0
}
GUI.MENU_ROLLSPEED = {
	"10%","20%","30%","40%","50%","60%","70%","80%","90%","100%","110%","120%","130%","140%","150%","160%","170%","180%","190%","200%","210%","220%","230%","240%","250%","260%","270%","280%","290%","300%","400%","500%",
}
GUI.VALUE_ROLLSPEED = {
	0.1,0.2,0.3,0.4,0.5,0.6,0.7,0.8,0.9,1.0,1.1,1.2,1.3,1.4,1.5,1.6,1.7,1.8,1.9,2.0,2.1,2.2,2.3,2.4,2.5,2.6,2.7,2.8,2.9,3.0,4.0,5.0
}

function GUI.initGui(self)
	if not GUI.createdGUI then -- Skip if we've already done this once
		GUI.createdGUI = true

		--Setup Settings Elements

		--Show In Help Option--
			self.menuOption_ShowInHelp = self.checkInvertYLook:clone()
			self.menuOption_ShowInHelp.target = GUI
			self.menuOption_ShowInHelp.id = "GUI_ShowInHelp"
			self.menuOption_ShowInHelp:setCallback("onClickCallback", "onMenuOptionChanged_ShowInHelp")
			self.menuOption_ShowInHelp:setDisabled(false)
		
			local settingTitle = self.menuOption_ShowInHelp.elements[4]
			local toolTip      = self.menuOption_ShowInHelp.elements[6]

			self.menuOption_ShowInHelp:setTexts(GUI.MENU_SHOWINHELP)
			settingTitle:setText(g_i18n:getText("menu_ShowInHelpTitle"))
			toolTip:setText(g_i18n:getText("menu_ShowInHelpTooltip"))
			
			
		--Use Super Strength--
			self.menuOption_SuperStrength = self.checkInvertYLook:clone()
			self.menuOption_SuperStrength.target = GUI
			self.menuOption_SuperStrength.id = "GUI_SuperStrength"
			self.menuOption_SuperStrength:setCallback("onClickCallback", "onMenuOptionChanged_SuperStength")
			self.menuOption_SuperStrength:setDisabled(false)
		
			local settingTitle = self.menuOption_SuperStrength.elements[4]
			local toolTip      = self.menuOption_SuperStrength.elements[6]

			self.menuOption_SuperStrength:setTexts(GUI.MENU_SUPERSTRENGTH)
			settingTitle:setText(g_i18n:getText("menu_TOGGLE_STRENGTH"))
			toolTip:setText(g_i18n:getText("menu_TOGGLE_STRENGTH"))
		
		--Maximum Distance Metres--
			self.menuOption_MaxDistanceM = self.checkInvertYLook:clone()
			self.menuOption_MaxDistanceM.target = GUI
			self.menuOption_MaxDistanceM.id = "GUI_MaxDistanceM"
			self.menuOption_MaxDistanceM:setCallback("onClickCallback", "onMenuOptionChanged_MaxDistance")
			self.menuOption_MaxDistanceM:setDisabled(false)
		
			local settingTitle = self.menuOption_MaxDistanceM.elements[4]
			local toolTip      = self.menuOption_MaxDistanceM.elements[6]

			self.menuOption_MaxDistanceM:setTexts(GUI.MENU_MAXDISTANCE_METRES)
			settingTitle:setText(g_i18n:getText("menu_MaxDistanceMTitle"))
			toolTip:setText(g_i18n:getText("menu_MaxDistanceMTooltip"))
		
		--Maximum Distance Feet--
			self.menuOption_MaxDistanceF = self.checkInvertYLook:clone()
			self.menuOption_MaxDistanceF.target = GUI
			self.menuOption_MaxDistanceF.id = "GUI_MaxDistanceF"
			self.menuOption_MaxDistanceF:setCallback("onClickCallback", "onMenuOptionChanged_MaxDistance")
			self.menuOption_MaxDistanceF:setDisabled(false)
		
			local settingTitle = self.menuOption_MaxDistanceF.elements[4]
			local toolTip      = self.menuOption_MaxDistanceF.elements[6]

			self.menuOption_MaxDistanceF:setTexts(GUI.MENU_MAXDISTANCE_FEET)
			settingTitle:setText(g_i18n:getText("menu_MaxDistanceFTitle"))
			toolTip:setText(g_i18n:getText("menu_MaxDistanceFTooltip"))	
			
		--Grip Strength--
			self.menuOption_GripStrength = self.checkInvertYLook:clone()
			self.menuOption_GripStrength.target = GUI
			self.menuOption_GripStrength.id = "GUI_GripStrength"
			self.menuOption_GripStrength:setCallback("onClickCallback", "onMenuOptionChanged_GripStrength")
			self.menuOption_GripStrength:setDisabled(false)
		
			local settingTitle = self.menuOption_GripStrength.elements[4]
			local toolTip      = self.menuOption_GripStrength.elements[6]

			self.menuOption_GripStrength:setTexts(GUI.MENU_GRIPSTRENGTH)
			settingTitle:setText(g_i18n:getText("menu_GripStrengthTitle"))
			toolTip:setText(g_i18n:getText("menu_GripStrengthTooltip"))	
			
			
		--Push & Pull Speed Strength--
			self.menuOption_PushPullSpeed = self.checkInvertYLook:clone()
			self.menuOption_PushPullSpeed.target = GUI
			self.menuOption_PushPullSpeed.id = "GUI_Speed"
			self.menuOption_PushPullSpeed:setCallback("onClickCallback", "onMenuOptionChanged_PushPullSpeed")
			self.menuOption_PushPullSpeed:setDisabled(false)
		
			local settingTitle = self.menuOption_PushPullSpeed.elements[4]
			local toolTip      = self.menuOption_PushPullSpeed.elements[6]

			self.menuOption_PushPullSpeed:setTexts(GUI.MENU_PUSHPULLSPEED)
			settingTitle:setText(g_i18n:getText("menu_SpeedTitle"))
			toolTip:setText(g_i18n:getText("menu_SpeedTooltip"))	
		
		-- Nudge Speed Multiplier
			self.menuOption_NudgeSpeed = self.checkInvertYLook:clone()
			self.menuOption_NudgeSpeed.target = GUI
			self.menuOption_NudgeSpeed.id = "GUI_NudgeSpeed"
			self.menuOption_NudgeSpeed:setCallback("onClickCallback", "onMenuOptionChanged_NudgeSpeed")
			self.menuOption_NudgeSpeed:setDisabled(false)
		
			local settingTitle = self.menuOption_NudgeSpeed.elements[4]
			local toolTip      = self.menuOption_NudgeSpeed.elements[6]

			self.menuOption_NudgeSpeed:setTexts(GUI.MENU_NUDGESPEED)
			settingTitle:setText(g_i18n:getText("menu_NudgeSpeed"))
			toolTip:setText(g_i18n:getText("menu_NudgeSpeedTooltip"))			
			
		-- Vertical Speed Multiplier
			self.menuOption_VerticalSpeed = self.checkInvertYLook:clone()
			self.menuOption_VerticalSpeed.target = GUI
			self.menuOption_VerticalSpeed.id = "GUI_VerticalSpeed"
			self.menuOption_VerticalSpeed:setCallback("onClickCallback", "onMenuOptionChanged_VerticalSpeed")
			self.menuOption_VerticalSpeed:setDisabled(false)
		
			local settingTitle = self.menuOption_VerticalSpeed.elements[4]
			local toolTip      = self.menuOption_VerticalSpeed.elements[6]

			self.menuOption_VerticalSpeed:setTexts(GUI.MENU_VERTICALSPEED)
			settingTitle:setText(g_i18n:getText("menu_VerticalSpeed"))
			toolTip:setText(g_i18n:getText("menu_VerticalSpeedTooltip"))

		-- Roll Speed Multiplier
			self.menuOption_RollSpeed = self.checkInvertYLook:clone()
			self.menuOption_RollSpeed.target = GUI
			self.menuOption_RollSpeed.id = "GUI_RollSpeed"
			self.menuOption_RollSpeed:setCallback("onClickCallback", "onMenuOptionChanged_RollSpeed")
			self.menuOption_RollSpeed:setDisabled(false)
		
			local settingTitle = self.menuOption_RollSpeed.elements[4]
			local toolTip      = self.menuOption_RollSpeed.elements[6]

			self.menuOption_RollSpeed:setTexts(GUI.MENU_ROLLSPEED)
			settingTitle:setText(g_i18n:getText("menu_RollSpeed"))
			toolTip:setText(g_i18n:getText("menu_RollSpeedTooltip"))				
			
		--Check if Metric System or Imperial
			local result = g_i18n:getSpeedMeasuringUnit()
			if result == "mph" then 
				PrecisionHands.isMetric = false
			end

		--Add elements to the Main Menu
			local title = TextElement.new()
			title:applyProfile("settingsMenuSubtitle", true)
			title:setText(g_i18n:getText("menu_PrecisionHandsTitle"))
			self.boxLayout:addElement(title)
			self.boxLayout:addElement(self.menuOption_PushPullSpeed)
			self.boxLayout:addElement(self.menuOption_NudgeSpeed)
			self.boxLayout:addElement(self.menuOption_VerticalSpeed)
			self.boxLayout:addElement(self.menuOption_RollSpeed)
			self.boxLayout:addElement(self.menuOption_GripStrength)
			
			if PrecisionHands.isMetric == true then
				self.boxLayout:addElement(self.menuOption_MaxDistanceM)
			else
				self.boxLayout:addElement(self.menuOption_MaxDistanceF)
			end
			
			self.boxLayout:addElement(self.menuOption_ShowInHelp)
			
			if PrecisionHands.lumberJackLoaded == true then
				self.menuOption_SuperStrength.disabled = true
				self.menuOption_SuperStrength.elements[6]:setText(g_i18n:getText("menu_USING_LJ"))
			end
			self.boxLayout:addElement(self.menuOption_SuperStrength)
			GUI.UpdateMenuSettings(self)
	
	else

	GUI.UpdateMenuSettings(self)

	end

end

function GUI.UpdateMenuSettings(self)

	if (PrecisionHands.enableSuperStrength == true) then
		PrecisionHands.superStrengthIndex = 2
	else
		PrecisionHands.superStrengthIndex = 1
	end
	self.menuOption_ShowInHelp:setState(PrecisionHands.showInHelpIndex)
	self.menuOption_SuperStrength:setState(PrecisionHands.superStrengthIndex)
	self.menuOption_MaxDistanceF:setState(PrecisionHands.maxDistanceIndex)
	self.menuOption_MaxDistanceM:setState(PrecisionHands.maxDistanceIndex)
	self.menuOption_GripStrength:setState(PrecisionHands.gripStrengthIndex)
	self.menuOption_PushPullSpeed:setState(PrecisionHands.pushPullSpeedIndex)
	self.menuOption_NudgeSpeed:setState(PrecisionHands.nudgeSpeedIndex)
	self.menuOption_VerticalSpeed:setState(PrecisionHands.verticalSpeedIndex)
	self.menuOption_RollSpeed:setState(PrecisionHands.rollSpeedIndex)
	
end

function GUI.onMenuOptionChanged_ShowInHelp(state, info)
	PrecisionHands.showInHelpIndex = info
	if info == 1 then
		PrecisionHands.showInHelp = false
	else
		PrecisionHands.showInHelp = true
	end
end


function GUI.onMenuOptionChanged_SuperStength(state, info)
	PrecisionHands.superStrengthIndex = info
	if info == 1 then
		PrecisionHands.enableSuperStrength = false
		
		print("super stength disabled")

	else
		PrecisionHands.enableSuperStrength = true
		print("super stength enabled")
		--PrecisionHands:RegisterSuperStrengthActionEvents()
	end
end



function GUI.onMenuOptionChanged_PushPullSpeed(state, info)
	PrecisionHands.pushPullSpeedIndex = info
	PrecisionHands.pushPullSpeed = GUI.VALUE_PUSHPULLSPEED[info]
end

function GUI.onMenuOptionChanged_NudgeSpeed(state, info)
	PrecisionHands.nudgeSpeedIndex = info
	PrecisionHands.nudgeSpeed = GUI.VALUE_NUDGESPEED[info]
end

function GUI.onMenuOptionChanged_VerticalSpeed(state, info)
	PrecisionHands.verticalSpeedIndex = info
	PrecisionHands.verticalSpeed = GUI.VALUE_VERTICALSPEED[info]
end

function GUI.onMenuOptionChanged_MaxDistance(state, info)
	PrecisionHands.maxDistanceIndex = info
	PrecisionHands.maxDistance = GUI.VALUE_MAXDISTANCE[info]
end

function GUI.onMenuOptionChanged_GripStrength(state, info)
	PrecisionHands.gripStrengthIndex = info
	PrecisionHands.gripStrengthMultiplier = GUI.VALUE_GRIPSTRENGTH[info]
end

function GUI.onMenuOptionChanged_RollSpeed(state, info)
	PrecisionHands.rollSpeedIndex = info
	PrecisionHands.rollSpeed = GUI.VALUE_ROLLSPEED[info]
end