--[[------------------------------------------------------------------------------------------------

Precision Hands Mod for Farming Simulator 2022
Author: Rusty Tractor Modding

--]]-----------------------------------------------------------------------------------------------


XML = {}

function XML:LoadSettings()
	if not fileExists(PrecisionHands.settingsXMLFile) then
        --First Time Launch, will use default settings
        return
    end

    local xmlFile = XMLFile.load("XML", PrecisionHands.settingsXMLFile)
    local key = "PrecisionHands.setting"
    PrecisionHands.showInHelpIndex = xmlFile:getInt(key..".showInHelpIndex")
	if PrecisionHands.showInHelpIndex == 1 then
		PrecisionHands.showInHelp = false
	else
		PrecisionHands.showInHelp = true
	end
	
	PrecisionHands.maxDistanceIndex = xmlFile:getInt(key..".maxDistanceIndex")
	PrecisionHands.maxDistance = GUI.VALUE_MAXDISTANCE[PrecisionHands.maxDistanceIndex]
	
	
	PrecisionHands.gripStrengthIndex = xmlFile:getInt(key..".gripStrengthIndex")
	PrecisionHands.gripStrength = GUI.VALUE_GRIPSTRENGTH[PrecisionHands.gripStrengthIndex]
	
	
	PrecisionHands.pushPullSpeedIndex = xmlFile:getInt(key..".pushPullSpeedIndex")
	PrecisionHands.pushPullSpeed = GUI.VALUE_PUSHPULLSPEED[PrecisionHands.pushPullSpeedIndex]


	PrecisionHands.nudgeSpeedIndex = xmlFile:getInt(key..".nudgeSpeedIndex")
	PrecisionHands.nudgeSpeed = GUI.VALUE_NUDGESPEED[PrecisionHands.nudgeSpeedIndex]
	
	PrecisionHands.rollSpeedIndex = xmlFile:getInt(key..".rollSpeedIndex")
	PrecisionHands.rollSpeed = GUI.VALUE_ROLLSPEED[PrecisionHands.rollSpeedIndex]
	
	PrecisionHands.verticalSpeedIndex = xmlFile:getInt(key..".verticalSpeedIndex")
	PrecisionHands.verticalSpeed = GUI.VALUE_VERTICALSPEED[PrecisionHands.verticalSpeedIndex]

	PrecisionHands.superStrengthIndex = xmlFile:getInt(key..".superStrengthIndex")
	if PrecisionHands.superStrengthIndex == 1 then
		PrecisionHands.enableSuperStrength = false
	else
		PrecisionHands.enableSuperStrength = true
	end

    xmlFile:delete()


end


function XML:SaveSettings()
	
    local xmlFile = XMLFile.create("XML", PrecisionHands.settingsXMLFile, "PrecisionHands")

    local key = "PrecisionHands.setting"
	
    xmlFile:setInt(key .. ".showInHelpIndex", PrecisionHands.showInHelpIndex)
	xmlFile:setInt(key .. ".maxDistanceIndex", PrecisionHands.maxDistanceIndex)
	xmlFile:setInt(key .. ".gripStrengthIndex", PrecisionHands.gripStrengthIndex)
	xmlFile:setInt(key .. ".pushPullSpeedIndex", PrecisionHands.pushPullSpeedIndex)
	xmlFile:setInt(key .. ".nudgeSpeedIndex", PrecisionHands.nudgeSpeedIndex)
	xmlFile:setInt(key .. ".rollSpeedIndex", PrecisionHands.rollSpeedIndex)
	xmlFile:setInt(key .. ".verticalSpeedIndex", PrecisionHands.verticalSpeedIndex)
	xmlFile:setInt(key .. ".superStrengthIndex", PrecisionHands.superStrengthIndex)
	
    xmlFile:save()
    xmlFile:delete()

end


function XML:SaveTables(theTable,key,value)
	
    local xmlFile = XMLFile.create("XML", PrecisionHands.settingsXMLFile, "PrecisionHands_Tables")

	
    xmlFile:setString(theTable .. tostring(key), tostring(value))

    xmlFile:save()
    xmlFile:delete()

end